import { ServiceStore } from "./ServiceStore";
import { IService } from "./Service";
export interface StoreListener<StateT> {
    (newState: StateT, oldState: StateT): void;
}
export interface StoreSubscription {
    (): void;
}
export declare type ServiceOrStore = ServiceStore<any> | IService<any>;
export declare class AppStore<StateT extends object> {
    private listeners;
    private appState;
    private stores;
    private activityListeners;
    constructor();
    init(servicesOrStores: ServiceOrStore[]): void;
    private extractStore(serviceOrStore);
    getState(): StateT;
    subscribe(listener: StoreListener<StateT>): StoreSubscription;
    unsubscribe(listener: StoreListener<StateT>): void;
    commit(oldState: any, newState: any): StateT;
    private emit(oldState, newState);
    private registerStore<StateT>(store);
    private findConflictingPath(path);
    registerListener(listener: ActivityListener): void;
    unregisterListener(listener: ActivityListener): void;
    private emitActivityEvent(func);
    _onActivityError(err: any): void;
    _onActivitySuccess(res: any): void;
}
export interface ActivityListener {
    onActivitySuccess(res: any): any;
    onActivityError(err: any): any;
}
